open import Relation.Binary.PropositionalEquality
open import Data.List using (List) renaming (_∷_ to _∷ˡ_; [] to []ˡ; _++_ to _++ˡ_)
open import Data.Nat.Properties using (<ᵇ⇒<)
open import Data.Vec
open import Data.Product

import Data.String as S

open import Base
open import UTF-8
open import Bits-and-Bytes

module UTF-8.Test where

en-ex4 : enbits 0x5 (<ᵇ⇒< _ _ _) ≡ 𝟙 ∷ 𝟘 ∷ 𝟙 ∷ 𝟘 ∷ []
en-ex4 = refl
en-ex8 : enbits 0x69 (<ᵇ⇒< _ _ _) ≡ 𝟙 ∷ 𝟘 ∷ 𝟘 ∷ 𝟙 ∷ 𝟘 ∷ 𝟙 ∷ 𝟙 ∷ 𝟘 ∷ []
en-ex8 = refl
un-ex4 : unbits (𝟙 ∷ 𝟘 ∷ 𝟙 ∷ 𝟘 ∷ []) ≡ (0x5 , _)
un-ex4 = refl
un-ex8 : unbits (𝟙 ∷ 𝟘 ∷ 𝟘 ∷ 𝟙 ∷ 𝟘 ∷ 𝟙 ∷ 𝟙 ∷ 𝟘 ∷ []) ≡ (0x69 , _)
un-ex8 = refl
bb8-ex : Byte-to-Bit8 (< 0x69 >) ≡ 𝟙 ∷ 𝟘 ∷ 𝟘 ∷ 𝟙 ∷ 𝟘 ∷ 𝟙 ∷ 𝟙 ∷ 𝟘 ∷ []
bb8-ex = refl
b8b-ex : Bit8-to-Byte (𝟙 ∷ 𝟘 ∷ 𝟘 ∷ 𝟙 ∷ 𝟘 ∷ 𝟙 ∷ 𝟙 ∷ 𝟘 ∷ []) ≡ < 0x69 >
b8b-ex = refl

encode-a : encode-char 'a' ≡ < 97 > ∷ˡ []ˡ
encode-a = refl
encode-ö : encode-char 'ö' ≡ < 0xc3 > ∷ˡ < 0xb6 > ∷ˡ []ˡ
encode-ö = refl
encode-∘ : encode-char '∘' ≡ < 0xe2 > ∷ˡ < 0x88 > ∷ˡ < 0x98 > ∷ˡ []ˡ
encode-∘ = refl
encode-𐄣 : encode-char '𐄣' ≡ < 0xf0 > ∷ˡ < 0x90 > ∷ˡ < 0x84 > ∷ˡ < 0xa3 > ∷ˡ []ˡ
encode-𐄣 = refl
encode-blah : encode-string "aö∘𐄣"
            ≡ < 0x61 >
            ∷ˡ < 0xc3 > ∷ˡ < 0xb6 >
            ∷ˡ < 0xe2 > ∷ˡ < 0x88 > ∷ˡ < 0x98 >
            ∷ˡ < 0xf0 > ∷ˡ < 0x90 > ∷ˡ < 0x84 > ∷ˡ < 0xa3 >
            ∷ˡ []ˡ
encode-blah = refl
decode-blah : decode-string
            ( < 0x61 >
            ∷ˡ < 0xc3 > ∷ˡ < 0xb6 >
            ∷ˡ < 0xe2 > ∷ˡ < 0x88 > ∷ˡ < 0x98 >
            ∷ˡ < 0xf0 > ∷ˡ < 0x90 > ∷ˡ < 0x84 > ∷ˡ < 0xa3 >
            ∷ˡ []ˡ )
            ≡ real "aö∘𐄣"
decode-blah = refl
